<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>

<%!
public enum Gender {
	FEMALE(1), MALE(2);
	
	private final int type;
	Gender(int type) {
		this.type = type;
	}
	
	public int getType() {
		return type;
	}

	public static Gender valueOf(int value) {
		switch (value) { // switch
		case 1:
			return FEMALE;
		case 2:
			return MALE;
		}
		return null;
	}
}

public class Person {

    private String name;
    private int age;
    private Gender gender;
    
    public Person() { 
    	this("K", 10, Gender.FEMALE); 
	}

    public Person(String name, int age) {
        this.name = name;
        this.age = age;
        this.gender = Gender.FEMALE;
    }

    public Person(String name, int age, Gender gender) {
        this.name = name;
        this.age = age;
        this.gender = gender;
    }

    public void setName(String name) { 
		this.name = name; 
	}
    
	public void setAge(int age) { 
		this.age = age; 
	}
    
	public void setGender(Gender gender) { 
		this.gender = gender; 
	}
    
	public String getName() { 
		return name; 
	}

    public int getAge() { 
		return age; 
	}

    public Gender getGender() { 
		return gender; 
	}

    public void print() { 
		System.out.println(this); 
	}

    @Override public String toString() { 
		return "Person Name=" + name + " Age=" + age + " Gender=" + gender; 
	}
}

public class PersonManager {
	private List<Person> pList = new ArrayList<Person>();

	public PersonManager() {
		pList.add(new Person("Kyoung", 10, Gender.FEMALE));
		pList.add(new Person("Shin", 20, Gender.FEMALE));
		pList.add(new Person("Park", 30, Gender.FEMALE));
		pList.add(new Person("Kim", 40, Gender.MALE));
		pList.add(new Person("Lee", 50, Gender.MALE));
		pList.add(new Person("Cho", 60, Gender.MALE));
		pList.add(new Person("Choi", 70, Gender.MALE));
		pList.add(new Person("Kang", 80, Gender.MALE));
		pList.add(new Person("Whang", 90, Gender.FEMALE));
	}
	
	public List<Person> getList() {
		return pList;
	}

	public void setList(List<Person> list) {
		this.pList = list;
	}
	
	// add 
	public void add(Person person) {
		pList.add(person);
	}
	
	// remove all 
	public void removeAll() {
		Iterator<Person> it = pList.iterator();
		while (it.hasNext()) {
		    Person p = it.next();
			it.remove();
		}
	}
	
	// remove 
	public void remove(Person other) {
		Iterator<Person> it = pList.iterator();
		while (it.hasNext()) {
		    Person p = it.next();
		    if (p == other) {
				it.remove();
		    }
		}
	}
	
	// get 
	public Person get(Person other) {
		Iterator<Person> it = pList.iterator();
		while (it.hasNext()) {
			Person p = it.next();
		    if (p == other) {
		    	return p;
		    }
		}
		return null;
	}

	// get (by name)
	public Person get(String name) {
		Person person = null;
		for (Person p : pList) {
			if (p != null && p.getName().equals(name)) {
				person = p;
				break;
			}
		}
		return person;
	}

	// replace
	public void replace(String name, Person other) {
		int index = pList.indexOf(get(name));
		pList.set(index, other);
	}
}

PersonManager manager = new PersonManager();
%>